/*
 * 商学院签到任务
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolSignInTaskController : BaseController
    {
        public SchoolSignInTaskController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院签到任务列表

        /// <summary>
        /// 根据条件查询商学院签到任务列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolSignInTask data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院签到任务列表

        /// <summary>
        /// 商学院签到任务列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolSignInTask data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("TaskName", "1"); //任务名称
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolSignInTask", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
                dic["RecommendName"] = dic["Recommend"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院签到任务

        /// <summary>
        /// 增加或修改商学院签到任务信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商学院签到任务

        /// <summary>
        /// 增加或修改商学院签到任务信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolSignInTask data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("TaskName", data.TaskName); //任务名称
            Fields.Add("Details", data.Details); //简介
            Fields.Add("ListPic", data.ListPic); //图标
            Fields.Add("Url", data.Url); //跳转链接
            Fields.Add("UrlParam", data.UrlParam); //跳转参数
            Fields.Add("Recommend", data.Recommend); //推荐

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("SchoolSignInTask", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolSignInTask", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商学院签到任务

        /// <summary>
        /// 增加或修改商学院签到任务信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolSignInTask editData = db.SchoolSignInTask.FirstOrDefault(m => m.Id == Id) ?? new SchoolSignInTask();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院签到任务

        /// <summary>
        /// 增加或修改商学院签到任务信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolSignInTask data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("TaskName", data.TaskName); //任务名称
            Fields.Add("Details", data.Details); //简介
            Fields.Add("ListPic", data.ListPic); //图标
            Fields.Add("Url", data.Url); //跳转链接
            Fields.Add("UrlParam", data.UrlParam); //跳转参数
            Fields.Add("Recommend", data.Recommend); //推荐

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTask", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolSignInTask", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商学院签到任务信息

        /// <summary>
        /// 删除商学院签到任务信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTask", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTask", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTask", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTask", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTask", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTask", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("SchoolSignInTask", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolSignInTask", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.SchoolSignInTask.Add(new SchoolSignInTask()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "SchoolSignInTask", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolSignInTask data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("TaskName", "1"); //任务名称
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolSignInTask", Fields, "Id desc", "0", 1, 20000, condition, "Details,Url", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
                dic["RecommendName"] = dic["Recommend"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("Details", "简介");
            ReturnFields.Add("Url", "跳转链接");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolSignInTask", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
